/*******************************************************************************
* File Name: SW_PUSHBUTTON.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_SW_PUSHBUTTON_H) /* Pins SW_PUSHBUTTON_H */
#define CY_PINS_SW_PUSHBUTTON_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "SW_PUSHBUTTON_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SW_PUSHBUTTON_Write(uint8 value) ;
void    SW_PUSHBUTTON_SetDriveMode(uint8 mode) ;
uint8   SW_PUSHBUTTON_ReadDataReg(void) ;
uint8   SW_PUSHBUTTON_Read(void) ;
uint8   SW_PUSHBUTTON_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SW_PUSHBUTTON_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define SW_PUSHBUTTON_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define SW_PUSHBUTTON_DM_RES_UP          PIN_DM_RES_UP
#define SW_PUSHBUTTON_DM_RES_DWN         PIN_DM_RES_DWN
#define SW_PUSHBUTTON_DM_OD_LO           PIN_DM_OD_LO
#define SW_PUSHBUTTON_DM_OD_HI           PIN_DM_OD_HI
#define SW_PUSHBUTTON_DM_STRONG          PIN_DM_STRONG
#define SW_PUSHBUTTON_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define SW_PUSHBUTTON_MASK               SW_PUSHBUTTON__MASK
#define SW_PUSHBUTTON_SHIFT              SW_PUSHBUTTON__SHIFT
#define SW_PUSHBUTTON_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SW_PUSHBUTTON_PS                     (* (reg8 *) SW_PUSHBUTTON__PS)
/* Data Register */
#define SW_PUSHBUTTON_DR                     (* (reg8 *) SW_PUSHBUTTON__DR)
/* Port Number */
#define SW_PUSHBUTTON_PRT_NUM                (* (reg8 *) SW_PUSHBUTTON__PRT) 
/* Connect to Analog Globals */                                                  
#define SW_PUSHBUTTON_AG                     (* (reg8 *) SW_PUSHBUTTON__AG)                       
/* Analog MUX bux enable */
#define SW_PUSHBUTTON_AMUX                   (* (reg8 *) SW_PUSHBUTTON__AMUX) 
/* Bidirectional Enable */                                                        
#define SW_PUSHBUTTON_BIE                    (* (reg8 *) SW_PUSHBUTTON__BIE)
/* Bit-mask for Aliased Register Access */
#define SW_PUSHBUTTON_BIT_MASK               (* (reg8 *) SW_PUSHBUTTON__BIT_MASK)
/* Bypass Enable */
#define SW_PUSHBUTTON_BYP                    (* (reg8 *) SW_PUSHBUTTON__BYP)
/* Port wide control signals */                                                   
#define SW_PUSHBUTTON_CTL                    (* (reg8 *) SW_PUSHBUTTON__CTL)
/* Drive Modes */
#define SW_PUSHBUTTON_DM0                    (* (reg8 *) SW_PUSHBUTTON__DM0) 
#define SW_PUSHBUTTON_DM1                    (* (reg8 *) SW_PUSHBUTTON__DM1)
#define SW_PUSHBUTTON_DM2                    (* (reg8 *) SW_PUSHBUTTON__DM2) 
/* Input Buffer Disable Override */
#define SW_PUSHBUTTON_INP_DIS                (* (reg8 *) SW_PUSHBUTTON__INP_DIS)
/* LCD Common or Segment Drive */
#define SW_PUSHBUTTON_LCD_COM_SEG            (* (reg8 *) SW_PUSHBUTTON__LCD_COM_SEG)
/* Enable Segment LCD */
#define SW_PUSHBUTTON_LCD_EN                 (* (reg8 *) SW_PUSHBUTTON__LCD_EN)
/* Slew Rate Control */
#define SW_PUSHBUTTON_SLW                    (* (reg8 *) SW_PUSHBUTTON__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define SW_PUSHBUTTON_PRTDSI__CAPS_SEL       (* (reg8 *) SW_PUSHBUTTON__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define SW_PUSHBUTTON_PRTDSI__DBL_SYNC_IN    (* (reg8 *) SW_PUSHBUTTON__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define SW_PUSHBUTTON_PRTDSI__OE_SEL0        (* (reg8 *) SW_PUSHBUTTON__PRTDSI__OE_SEL0) 
#define SW_PUSHBUTTON_PRTDSI__OE_SEL1        (* (reg8 *) SW_PUSHBUTTON__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define SW_PUSHBUTTON_PRTDSI__OUT_SEL0       (* (reg8 *) SW_PUSHBUTTON__PRTDSI__OUT_SEL0) 
#define SW_PUSHBUTTON_PRTDSI__OUT_SEL1       (* (reg8 *) SW_PUSHBUTTON__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define SW_PUSHBUTTON_PRTDSI__SYNC_OUT       (* (reg8 *) SW_PUSHBUTTON__PRTDSI__SYNC_OUT) 


#if defined(SW_PUSHBUTTON__INTSTAT)  /* Interrupt Registers */

    #define SW_PUSHBUTTON_INTSTAT                (* (reg8 *) SW_PUSHBUTTON__INTSTAT)
    #define SW_PUSHBUTTON_SNAP                   (* (reg8 *) SW_PUSHBUTTON__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins SW_PUSHBUTTON_H */


/* [] END OF FILE */
