/*******************************************************************************
* FILENAME: cyfitter_cfg.c
* PSoC Creator 2.0
*
* Description:
* This file is automatically generated by PSoC Creator with device 
* initialization code.
*
* THIS FILE SHOULD NOT BE MODIFIED.
*
********************************************************************************
* Copyright 2011, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include <string.h>
#include <cytypes.h>
#include <cydevice_trm.h>
#include <cyfitter.h>
#include <CyLib.h>
#include <cyfitter_cfg.h>

/* Clock startup error codes                                                   */
#define CYCLOCKSTART_NO_ERROR    0
#define CYCLOCKSTART_XTAL_ERROR  1
#define CYCLOCKSTART_32KHZ_ERROR 2
#define CYCLOCKSTART_PLL_ERROR   3

/*******************************************************************************
* Function Name: CyClockStartupError
********************************************************************************
* Summary:
*  If an error is encountered during clock configuration (crystal startup error,
*  PLL lock error, etc) the system will end up here.  Unless reimplemented by 
*  the customer, an infinite loop will be encountered.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
__attribute__ ((unused))
#endif
static void CyClockStartupError(uint8 errorCode)
{
    /* To remove the compiler warning if errorCode not used.                */
    errorCode = errorCode;

    /* `#START CyClockStartupError` */

    /* `#END` */

    /* If nothing else, stop here since the clocks have not started         */
    /* correctly.                                                           */
    while(1) {}
}


#undef CYCODE
#undef CYDATA
#undef CYXDATA
#undef CYFAR
#if defined(__GNUC__) || defined(__ARMCC_VERSION)
	#define CYCODE
	#define CYDATA
	#define CYXDATA
	#define CYFAR

	#define CYPACKED __attribute__ ((packed))
	#define CYALIGNED __attribute__ ((aligned))
	
	#if defined(__ARMCC_VERSION)
		#define CY_CFG_MEMORY_BARRIER() __memory_changed()
	#else
		#define CY_CFG_MEMORY_BARRIER() __sync_synchronize()
	#endif
	
    /*******************************************************************************
    * Function Name: cymemzero8
    ********************************************************************************
    * Summary:
    *  This function is provided as a way to initialize a block of memory to zero
    *  one byte at a time.  While this is a 32bit processor, some of the 
    *  configuration registers are only 8bits wide.  This allows us to initialize
    *  just the registers we care about.
    *
    * Parameters:  
    *   addr  - The first address to start writing zero to.
    *   count - The number of bytes to write 0 to.
    *
    * Return:
    *   void
    *
    *******************************************************************************/
    __attribute__ ((unused))
    static void cymemzero8(void *addr, unsigned int count)
    {
	    volatile uint8 *addr8 = (uint8 *)addr;
	    while (count--)
	    {
		    *addr8 = 0;
		    addr8++;
	    }
    }

    /*******************************************************************************
    * Function Name: cymemcpy8
    ********************************************************************************
    * Summary:
    *  This function is provided as a way to copy data from one location to another
    *  one byte at a time.  While this is a 32bit processor, some of the 
    *  configuration registers are only 8bits wide.  This allows us to initialize
    *  just the registers we care about.
    *
    * Parameters:  
    *   dest  - The destination address to copy data to.
    *   src   - The source address to copy data from.
    *   count - The number of bytes to copy from 'src' to 'dest'.
    *
    * Return:
    *   void
    *
    *******************************************************************************/
    __attribute__ ((unused))
    static void cymemcpy8(void *dest, const void *src, unsigned int count)
    {
	    volatile uint8 *dest8 = (uint8 *)dest;
	    const uint8 *src8 = (const uint8 *)src;

	    while (count--)
	    {
		    *dest8 = *src8;
		    dest8++;
		    src8++;
	    }
    }

    #define CYMEMZERO8(a,c) cymemzero8((a),(c))
    #define CYCONFIGCPY8(d,s,c) cymemcpy8((d),(s),(c))
    #define CYCONFIGCPYCODE8(d,s,c) cymemcpy8((d),(s),(c))
	
	#define CYMEMZERO(a,c) memset((a),0,(c))
	#define CYCONFIGCPY(d,s,c) memcpy((d),(s),(c))
	#define CYCONFIGCPYCODE(d,s,c) memcpy((d),(s),(c))
#else
	#error Unsupported toolchain
#endif

/* Defines the layout and meaning of each entry in the cfg_memset_list used for clearing registers */
typedef struct {
	void CYFAR *address;
	uint16 size;
} CYPACKED cfg_memset_t;

/* Defines the layout and meaning of each entry in the cfg_memcpy_list used for initializing registers */
typedef struct {
	void CYFAR *dest;
	const void CYCODE *src;
	uint16 size;
} CYPACKED cfg_memcpy_t;

/* Contains the regions of memory that must be set to 0 during configuration */
#define CFG_MEMSET_COUNT (sizeof(cfg_memset_list)/sizeof(*cfg_memset_list))
static const cfg_memset_t CYCODE cfg_memset_list [] = {
	/* address, size */
	{(void CYFAR *)(CYREG_TMR0_CFG0), 11},
	{(void CYFAR *)(CYREG_PRT0_DR), 32},
	{(void CYFAR *)(CYREG_PRT3_DR), 16},
	{(void CYFAR *)(CYREG_PRT5_DR), 16},
	{(void CYFAR *)(CYREG_PRT12_DR), 16},
	{(void CYFAR *)(CYREG_PRT15_DR), 16},
	{(void CYFAR *)(CYDEV_UCFG_B0_P0_U0_BASE), 4096},
	{(void CYFAR *)(CYDEV_UCFG_B1_P2_U0_BASE), 2048},
	{(void CYFAR *)(CYDEV_UCFG_DSI0_BASE), 2560},
	{(void CYFAR *)(CYDEV_UCFG_DSI12_BASE), 512},
};

#define CY_CFG_BASE_ADDR_COUNT 21
typedef struct
{
	uint8 offset;
	uint8 value;
} CYPACKED cy_cfg_addrvalue_t;

static const uint32 CYCODE cy_cfg_addr_table[] = {
	0x40004F02u, /* Base address: 0x40004F00 Count: 2 */
	0x40006401u, /* Base address: 0x40006400 Count: 1 */
	0x40010501u, /* Base address: 0x40010500 Count: 1 */
	0x40010813u, /* Base address: 0x40010800 Count: 19 */
	0x4001090Eu, /* Base address: 0x40010900 Count: 14 */
	0x40010A25u, /* Base address: 0x40010A00 Count: 37 */
	0x40010B17u, /* Base address: 0x40010B00 Count: 23 */
	0x40011701u, /* Base address: 0x40011700 Count: 1 */
	0x40011801u, /* Base address: 0x40011800 Count: 1 */
	0x4001190Eu, /* Base address: 0x40011900 Count: 14 */
	0x40011B01u, /* Base address: 0x40011B00 Count: 1 */
	0x40014102u, /* Base address: 0x40014100 Count: 2 */
	0x40014203u, /* Base address: 0x40014200 Count: 3 */
	0x40014302u, /* Base address: 0x40014300 Count: 2 */
	0x40014506u, /* Base address: 0x40014500 Count: 6 */
	0x40014605u, /* Base address: 0x40014600 Count: 5 */
	0x40014706u, /* Base address: 0x40014700 Count: 6 */
	0x40014802u, /* Base address: 0x40014800 Count: 2 */
	0x40014C09u, /* Base address: 0x40014C00 Count: 9 */
	0x40014D04u, /* Base address: 0x40014D00 Count: 4 */
	0x40015004u, /* Base address: 0x40015000 Count: 4 */
};

static const cy_cfg_addrvalue_t CYCODE cy_cfg_data_table[] = {
	{0x01u, 0x80u},
	{0x09u, 0x36u},
	{0x8Au, 0x0Du},
	{0xE6u, 0x02u},
	{0xC0u, 0x65u},
	{0xC9u, 0xFFu},
	{0xCAu, 0xFFu},
	{0xCBu, 0xFFu},
	{0xCFu, 0x01u},
	{0xD0u, 0x18u},
	{0xD6u, 0x08u},
	{0xDAu, 0x08u},
	{0xDBu, 0x04u},
	{0xDDu, 0x99u},
	{0xE0u, 0x40u},
	{0xE2u, 0x40u},
	{0xE4u, 0x40u},
	{0xE5u, 0x40u},
	{0xE6u, 0x80u},
	{0xE8u, 0x80u},
	{0xEAu, 0x80u},
	{0xECu, 0x80u},
	{0xEEu, 0x80u},
	{0x48u, 0x06u},
	{0x5Bu, 0x02u},
	{0x60u, 0x80u},
	{0x78u, 0x80u},
	{0x82u, 0x10u},
	{0x8Cu, 0x10u},
	{0x9Cu, 0x80u},
	{0x9Du, 0x40u},
	{0xA0u, 0x06u},
	{0xD2u, 0x0Cu},
	{0xD6u, 0x01u},
	{0xD8u, 0x01u},
	{0xDEu, 0x08u},
	{0xE0u, 0x01u},
	{0x0Fu, 0x0Fu},
	{0x15u, 0x05u},
	{0x19u, 0x01u},
	{0x1Bu, 0x06u},
	{0x23u, 0x0Eu},
	{0x31u, 0x08u},
	{0x33u, 0x04u},
	{0x35u, 0x03u},
	{0x39u, 0x80u},
	{0x3Bu, 0x28u},
	{0x3Fu, 0x41u},
	{0x40u, 0x65u},
	{0x45u, 0xECu},
	{0x47u, 0x20u},
	{0x48u, 0x23u},
	{0x49u, 0xFFu},
	{0x4Au, 0xFFu},
	{0x4Bu, 0xFFu},
	{0x4Du, 0x83u},
	{0x4Eu, 0x03u},
	{0x4Fu, 0x01u},
	{0x50u, 0x18u},
	{0x54u, 0x01u},
	{0x59u, 0x08u},
	{0x5Au, 0x08u},
	{0x5Bu, 0x08u},
	{0x5Cu, 0x90u},
	{0x5Du, 0x99u},
	{0x60u, 0x40u},
	{0x62u, 0x40u},
	{0x64u, 0x40u},
	{0x65u, 0x40u},
	{0x66u, 0x80u},
	{0x68u, 0x80u},
	{0x6Au, 0x80u},
	{0x6Cu, 0x80u},
	{0x6Eu, 0x80u},
	{0x20u, 0x08u},
	{0x21u, 0x28u},
	{0x23u, 0x82u},
	{0x2Au, 0x01u},
	{0x31u, 0x28u},
	{0x3Bu, 0x40u},
	{0x48u, 0x06u},
	{0x49u, 0x05u},
	{0x50u, 0x02u},
	{0x52u, 0x01u},
	{0x59u, 0x05u},
	{0x5Bu, 0x80u},
	{0x73u, 0x40u},
	{0x78u, 0x80u},
	{0x85u, 0x40u},
	{0x87u, 0x02u},
	{0xCAu, 0x01u},
	{0xCCu, 0x06u},
	{0xCEu, 0x08u},
	{0xD2u, 0x0Cu},
	{0xD6u, 0x0Bu},
	{0xDEu, 0x08u},
	{0xE4u, 0x08u},
	{0xECu, 0x02u},
	{0xDBu, 0x04u},
	{0x68u, 0x44u},
	{0x6Bu, 0x22u},
	{0x70u, 0x10u},
	{0x71u, 0x40u},
	{0x72u, 0x10u},
	{0x73u, 0x80u},
	{0x84u, 0x44u},
	{0x8Fu, 0x80u},
	{0x94u, 0x20u},
	{0x96u, 0x10u},
	{0x9Du, 0x40u},
	{0xAFu, 0x02u},
	{0xE0u, 0x02u},
	{0xE4u, 0x02u},
	{0xB3u, 0x22u},
	{0x5Bu, 0x02u},
	{0xD6u, 0x40u},
	{0x87u, 0x02u},
	{0x9Fu, 0x02u},
	{0xE6u, 0x40u},
	{0x23u, 0x02u},
	{0xC8u, 0x10u},
	{0x59u, 0x01u},
	{0x61u, 0x02u},
	{0x64u, 0x08u},
	{0x66u, 0x80u},
	{0xD6u, 0x03u},
	{0xD8u, 0x03u},
	{0x84u, 0x08u},
	{0x9Cu, 0x08u},
	{0x9Du, 0x01u},
	{0x9Eu, 0x80u},
	{0xA5u, 0x02u},
	{0x81u, 0x02u},
	{0x8Du, 0x01u},
	{0x9Du, 0x01u},
	{0x9Eu, 0x80u},
	{0xA5u, 0x02u},
	{0xE4u, 0x02u},
	{0xAFu, 0x02u},
	{0xECu, 0x40u},
	{0x52u, 0x22u},
	{0x56u, 0x10u},
	{0x5Fu, 0x40u},
	{0x86u, 0x22u},
	{0x8Eu, 0x80u},
	{0x9Eu, 0x80u},
	{0xD4u, 0x07u},
	{0xD6u, 0x04u},
	{0xE4u, 0x08u},
	{0xB2u, 0x10u},
	{0xB3u, 0x40u},
	{0xE8u, 0x04u},
	{0xECu, 0x04u},
	{0x01u, 0x01u},
	{0x02u, 0x10u},
	{0x0Du, 0x01u},
	{0x12u, 0x10u},
};


/* IOPINS0_2 Address: CYREG_PRT2_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_2_VAL[] = {
	0x00, 0xC1, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPINS0_4 Address: CYREG_PRT4_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_4_VAL[] = {
	0x00, 0xF0, 0xF0, 0x00, 0xF0, 0x00, 0x00, 0x00};

/* IOPINS0_6 Address: CYREG_PRT6_DM0 Size (bytes): 8 */
static const uint8 CYCODE BS_IOPINS0_6_VAL[] = {
	0x00, 0xEF, 0xEF, 0x00, 0x0F, 0x00, 0x00, 0x00};

/* IOPORT_4 Address: CYDEV_PRTDSI_PRT4_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_4_VAL[] = {
	0x90, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00};

/* IOPORT_6 Address: CYDEV_PRTDSI_PRT6_BASE Size (bytes): 7 */
static const uint8 CYCODE BS_IOPORT_6_VAL[] = {
	0x0A, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00};


/*******************************************************************************
* Function Name: cfg_write_bytes32
********************************************************************************
* Summary:
*  This function is used for setting up the chip configuration areas that 
*  contain relativly sparse data.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
/* For 32-bit little-endian architectures */
static void cfg_write_bytes32(void)
{
	unsigned int i, j = 0;
	for (i = 0; i < CY_CFG_BASE_ADDR_COUNT; i++)
	{
		uint32 baseAddr = cy_cfg_addr_table[i];
		uint8 count = baseAddr & 0xFFu;
		baseAddr &= 0xFFFFFF00u;
		while (count--)
		{
			CY_SET_XTND_REG8((void CYFAR *)(baseAddr + cy_cfg_data_table[j].offset), cy_cfg_data_table[j].value);
			j++;
		}
	}
}

/*******************************************************************************
* Function Name: ClockSetup
********************************************************************************
*
* Summary:
*  Performs the initialization of all of the clocks in the device based on the
*  settings in the Clock tab of the DWR.  This includes enabling the requested
*  clocks and setting the necessary dividers to produce the desired frequency. 
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
static void ClockSetup(void)
{
	reg32  timeout;
	reg32* timeout_p = &timeout;
	reg8   pllLock;


	/* Configure ILO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_SLOWCLK_ILO_CR0), 0x02);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_CR), 0x08);

	/* Configure IMO based on settings from Clock DWR */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_FASTCLK_IMO_CR), 0x03);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_IMO_TR1), (CY_GET_XTND_REG8(CYREG_FLSHID_CUST_TABLES_IMO_3MHZ)));

	/* Configure PLL based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_P), 0x0008);
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_FASTCLK_PLL_CFG0), 0x1051);
	/* Wait up to 250us for the PLL to lock */
	pllLock = 0;
	for (timeout = 250 / 10; *timeout_p && (pllLock != 0x03u); timeout--) { 
		pllLock = 0x03u & ((pllLock << 1) | ((CY_GET_XTND_REG8(CYREG_FASTCLK_PLL_SR) & 0x01u) >> 0));
		CyDelayCycles(10 * 12); /* Delay 10us based on 12MHz clock */
	}

	/* Configure Bus/Master Clock based on settings from Clock DWR */
	CY_SET_XTND_REG16((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x0103);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x07);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_BCFG2), 0x48);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_MSTR0), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CLKDIST_LD), 0x02);
}


/* Analog API Functions */

/*******************************************************************************
* Function Name: AnalogSetDefault
********************************************************************************
*
* Summary:
*  Sets up the analog portions of the chip to default values based on chip
*  configuration options from the project.
*
* Parameters:
*  void
*
* Return:
*  void
*
*******************************************************************************/
void AnalogSetDefault(void)
{
	CY_SET_XTND_REG16(CYREG_PM_ACT_CFG10, 0x0310);
	CY_SET_XTND_REG8(CYREG_DAC0_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC1_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC2_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_DAC3_CR0, 0x1E);
	CY_SET_XTND_REG8(CYREG_SAR0_CSR0, 0xC0);
	CY_SET_XTND_REG8(CYREG_SAR0_CSR3, 0x0C);
	CY_SET_XTND_REG8(CYREG_SAR1_CSR0, 0xC0);
	CY_SET_XTND_REG8(CYREG_SAR1_CSR3, 0x0C);
	CY_SET_XTND_REG8(CYREG_PUMP_CR0, 0x44);
}

#define CY_AMUX_UNUSED CYREG_BOOST_SR


/*******************************************************************************
* Function Name: cyfitter_cfg
********************************************************************************
* Summary:
*  This function is called by the start-up code for the selected device. It
*  performs all of the necessary device configuration based on the design
*  settings.  This includes settings from the Design Wide Resources (DWR) such
*  as Clocks and Pins as well as any component configuration that is necessary.
*
* Parameters:  
*   void
*
* Return:
*   void
*
*******************************************************************************/
void cyfitter_cfg(void)
{
#ifdef CYGlobalIntDisable
	/* Disable interrupts by default. Let user enable if/when they want. */
	CYGlobalIntDisable;
#endif

	/* Setup Flash Cycles based on 12MHz clock startup frequency. */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x40 : 0x41));

	/* Disable DMA channels so they can be configured for chip initialization */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH0_BASIC_CFG), 0x00);
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_PHUB_CH1_BASIC_CFG), 0x00);

	/* Enable analog pulldown switches */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_ANAIF_CFG_MISC_CR0), 0x01);

	/* Enable/Disable Debug functionality based on settings from System DWR */
	CY_SET_XTND_REG8(CYREG_MLOGIC_DBG_DBE, (CY_GET_XTND_REG8(CYREG_MLOGIC_DBG_DBE) | 0x01));

	{
		uint8 CYDATA i;

		/* Zero out critical memory blocks before beginning configuration */
		for (i = 0; i < CFG_MEMSET_COUNT; i++)
		{
			const cfg_memset_t CYCODE * CYDATA ms = &cfg_memset_list[i];
			CYMEMZERO(ms->address, ms->size);
		}

		cfg_write_bytes32();

		/* Perform normal device configuration. Order is not critical for these items. */
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT0_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT1_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT2_BASE), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT3_BASE), 7);
		CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT4_BASE), (void CYCODE *)(BS_IOPORT_4_VAL), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT5_BASE), 7);
		CYCONFIGCPYCODE8((void CYFAR *)(CYDEV_PRTDSI_PRT6_BASE), (void CYCODE *)(BS_IOPORT_6_VAL), 7);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT12_BASE), 6);
		CYMEMZERO8((void CYFAR *)(CYDEV_PRTDSI_PRT15_BASE), 7);

		/* Enable digital routing */
		CY_SET_XTND_REG8(CYREG_BCTL0_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL0_BANK_CTL) | 0x02u);
		CY_SET_XTND_REG8(CYREG_BCTL1_BANK_CTL, CY_GET_XTND_REG8(CYREG_BCTL1_BANK_CTL) | 0x02u);

		/* Enable UDB array */
		CY_SET_XTND_REG8(CYREG_PM_ACT_CFG0, CY_GET_XTND_REG8(CYREG_PM_ACT_CFG0) | 0x40u);
		CY_SET_XTND_REG8(CYREG_PM_AVAIL_CR2, CY_GET_XTND_REG8(CYREG_PM_AVAIL_CR2) | 0x10u);
	}

	/* Perform second pass device configuration. These items must be configured in specific order after the regular configuration is done. */
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT2_DM0), (void CYCODE *)(BS_IOPINS0_2_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT4_DM0), (void CYCODE *)(BS_IOPINS0_4_VAL), 8);
	CYCONFIGCPYCODE((void CYFAR *)(CYREG_PRT6_DM0), (void CYCODE *)(BS_IOPINS0_6_VAL), 8);


	/* Set Flash Cycles based on max possible frequency in case a glitch occurs during ClockSetup(). */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x00 : 0x01));
	/* Setup clocks based on selections from Clock DWR */
	ClockSetup();
	/* Set Flash Cycles based on newly configured 24.00MHz Bus Clock. */
	CY_SET_XTND_REG8((void CYFAR *)(CYREG_CACHE_CC_CTL), ((CYDEV_INSTRUCT_CACHE_ENABLED) ? 0x80 : 0x81));

	/* Perform basic analog initialization to defaults */
	AnalogSetDefault();

	/* Configure alternate active mode */
	CYCONFIGCPY((void CYFAR *)CYDEV_PM_STBY_BASE, (void CYFAR *)CYDEV_PM_ACT_BASE, 12);
	CY_SET_XTND_REG8(CYREG_PM_STBY_CFG0, CY_GET_XTND_REG8(CYREG_PM_STBY_CFG0) & ~0x02u);	/* Disable CPU */
}
